// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.19.4
// source: Math/Math.proto

package MathPB

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// MathSvcClient is the client API for MathSvc service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type MathSvcClient interface {
	Sum(ctx context.Context, in *SumArg, opts ...grpc.CallOption) (*SumRes, error)
	Factorial(ctx context.Context, in *FactorialArg, opts ...grpc.CallOption) (*FactorialRes, error)
}

type mathSvcClient struct {
	cc grpc.ClientConnInterface
}

func NewMathSvcClient(cc grpc.ClientConnInterface) MathSvcClient {
	return &mathSvcClient{cc}
}

func (c *mathSvcClient) Sum(ctx context.Context, in *SumArg, opts ...grpc.CallOption) (*SumRes, error) {
	out := new(SumRes)
	err := c.cc.Invoke(ctx, "/math.MathSvc/Sum", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mathSvcClient) Factorial(ctx context.Context, in *FactorialArg, opts ...grpc.CallOption) (*FactorialRes, error) {
	out := new(FactorialRes)
	err := c.cc.Invoke(ctx, "/math.MathSvc/Factorial", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// MathSvcServer is the server API for MathSvc service.
// All implementations must embed UnimplementedMathSvcServer
// for forward compatibility
type MathSvcServer interface {
	Sum(context.Context, *SumArg) (*SumRes, error)
	Factorial(context.Context, *FactorialArg) (*FactorialRes, error)
	mustEmbedUnimplementedMathSvcServer()
}

// UnimplementedMathSvcServer must be embedded to have forward compatible implementations.
type UnimplementedMathSvcServer struct {
}

func (UnimplementedMathSvcServer) Sum(context.Context, *SumArg) (*SumRes, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Sum not implemented")
}
func (UnimplementedMathSvcServer) Factorial(context.Context, *FactorialArg) (*FactorialRes, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Factorial not implemented")
}
func (UnimplementedMathSvcServer) mustEmbedUnimplementedMathSvcServer() {}

// UnsafeMathSvcServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to MathSvcServer will
// result in compilation errors.
type UnsafeMathSvcServer interface {
	mustEmbedUnimplementedMathSvcServer()
}

func RegisterMathSvcServer(s grpc.ServiceRegistrar, srv MathSvcServer) {
	s.RegisterService(&MathSvc_ServiceDesc, srv)
}

func _MathSvc_Sum_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SumArg)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MathSvcServer).Sum(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/math.MathSvc/Sum",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MathSvcServer).Sum(ctx, req.(*SumArg))
	}
	return interceptor(ctx, in, info, handler)
}

func _MathSvc_Factorial_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FactorialArg)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MathSvcServer).Factorial(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/math.MathSvc/Factorial",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MathSvcServer).Factorial(ctx, req.(*FactorialArg))
	}
	return interceptor(ctx, in, info, handler)
}

// MathSvc_ServiceDesc is the grpc.ServiceDesc for MathSvc service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var MathSvc_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "math.MathSvc",
	HandlerType: (*MathSvcServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Sum",
			Handler:    _MathSvc_Sum_Handler,
		},
		{
			MethodName: "Factorial",
			Handler:    _MathSvc_Factorial_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "Math/Math.proto",
}
